- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# BERSequenceDecoder Class Reference

`#include <asn.h>`

Inheritance diagram for BERSequenceDecoder:

List of all members.

## Detailed Description

BER Sequence Decoder.

Definition at line 177 of file asn.h.

## Public Member Functions
| BERSequenceDecoder (BufferedTransformation &inQueue, byte asnTag=SEQUENCE|CONSTRUCTED)
| BERSequenceDecoder (BERSequenceDecoder &inQueue, byte asnTag=SEQUENCE|CONSTRUCTED)
bool | IsDefiniteLength () const
lword | RemainingLength () const
bool | EndReached () const
byte | PeekByte () const
void | CheckByte (byte b)
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=NULL_CHANNEL, bool blocking=true)
| upon return, byteCount contains number of bytes that have finished being transfered, and returns the number of bytes left in the current transfer block
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const
| upon return, begin contains the start position of data yet to be finished copying, and returns the number of bytes left in the current transfer block
void | MessageEnd ()
void | IsolatedInitialize (const NameValuePairs &parameters)
unsigned int | NumberOfMessages () const
| number of times MessageEnd() has been received minus messages retrieved or skipped
bool | GetNextMessage ()
| start retrieving the next message
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=NULL_CHANNEL) const
void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
int | GetAutoSignalPropagation () const
size_t | Put2 (const byte *begin, size_t length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
bool | IsolatedFlush (bool, bool)
bool | IsolatedMessageSeriesEnd (bool)
size_t | ChannelPut2 (const std::string &channel, const byte *begin, size_t length, int messageEnd, bool blocking)
bool | ChannelMessageSeriesEnd (const std::string &, int, bool)
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| wait on this object
INPUT
bool | MessageEnd (int propagation=-1, bool blocking=true)
size_t | Put (byte inByte, bool blocking=true)
| input a byte for processing
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| input multiple bytes
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 16-bit word
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 32-bit word
virtual byte * | CreatePutSpace (size_t &size)
| request space which can be written into by the caller, and then used as input to Put()
virtual bool | CanModifyInput () const
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| input multiple bytes that may be modified by callee
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
WAITING
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| put wait objects into container
SIGNALS
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
RETRIEVAL OF ONE MESSAGE
virtual lword | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
virtual bool | AnyRetrievable () const
| returns whether any bytes are currently ready for retrieval
virtual size_t | Get (byte &outByte)
| try to retrieve a single byte
virtual size_t | Get (byte *outString, size_t getMax)
| try to retrieve multiple bytes
virtual size_t | Peek (byte &outByte) const
| peek at the next byte without removing it from the output buffer
virtual size_t | Peek (byte *outString, size_t peekMax) const
| peek at multiple bytes without removing them from the output buffer
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 16-bit word
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 32-bit word
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| try to peek at a 16-bit word
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| try to peek at a 32-bit word
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=NULL_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual lword | Skip (lword skipMax=LWORD_MAX)
| discard skipMax bytes from the output buffer
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=NULL_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=NULL_CHANNEL) const
| copy copyMax bytes of the buffered output, starting at position (relative to current position), to target as input
RETRIEVAL OF MULTIPLE MESSAGES
virtual lword | TotalBytesRetrievable () const
virtual bool | AnyMessages () const
| returns true if NumberOfMessages() > 0
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| skip count number of messages
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=NULL_CHANNEL)
virtual void | SkipAll ()
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL)
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL) const
virtual bool | GetNextMessageSeries ()
virtual unsigned int | NumberOfMessagesInThisSeries () const
virtual unsigned int | NumberOfMessageSeries () const
NON-BLOCKING TRANSFER OF OUTPUT
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=NULL_CHANNEL, bool blocking=true)
| upon return, messageCount contains number of messages that have finished being transfered, and returns the number of bytes left in the current transfer block
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL, bool blocking=true)
| returns the number of bytes left in the current transfer block
CHANNELS
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *begin, size_t length, int messageEnd, bool blocking)
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
virtual void | SetRetrievalChannel (const std::string &channel)
ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Static Public Attributes
static const std::string | NULL_CHANNEL
## Static Protected Member Functions
static int | DecrementPropagation (int propagation)
## Protected Attributes
BufferedTransformation & | m_inQueue
bool | m_finished
bool | m_definiteLength
lword | m_length
bool | m_messageEnd

## Member Function Documentation

bool Store::GetNextMessage | ( |  | ) | `[virtual, inherited]`

start retrieving the next message

Returns false if no more messages exist or this message is not completely retrieved.

Reimplemented from BufferedTransformation.

Definition at line 889 of file filters.cpp.

References BufferedTransformation::AnyRetrievable(), and Store::m_messageEnd.

void AutoSignaling< InputRejecting< BufferedTransformation > >::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

Reimplemented from BufferedTransformation.

Definition at line 168 of file simple.h.

size_t InputRejecting< BufferedTransformation >::Put2 | ( | const byte * | begin,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking |
| ) |  |  | `[inline, virtual, inherited]`

Implements BufferedTransformation.

Definition at line 99 of file simple.h.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object

This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference.

Definition at line 721 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | size_t & | size | ) | `[inline, virtual, inherited]`

request space which can be written into by the caller, and then used as input to Put()

Note:
  The purpose of this method is to help avoid doing extra memory allocations.

Reimplemented in MeterFilter, HashFilter, Redirector, OutputProxy, ArraySink, ArrayXorSink, ByteQueue, Multichannel< Filter >, and Multichannel< Sink >.

Definition at line 740 of file cryptlib.h.

Referenced by BufferedTransformation::ChannelCreatePutSpace(), and ArrayXorSink::CreatePutSpace().

virtual size_t BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking |
| ) |  |  | `[inline, virtual, inherited]`

input multiple bytes that may be modified by callee for blocking or non-blocking processing

Parameters:

  | messageEnd | means how many filters to signal MessageEnd to, including this one

Reimplemented in MeterFilter, FilterWithBufferedInput, OutputProxy, Multichannel< Filter >, and Multichannel< Sink >.

Definition at line 758 of file cryptlib.h.

Referenced by BufferedTransformation::ChannelPutModifiable2(), NetworkSource::DoPump(), and Filter::OutputModifiable().

void BufferedTransformation::GetWaitObjects | ( | WaitObjectContainer & | container,
|  | CallStack const & | callStack |
| ) |  |  | `[virtual, inherited]`

put wait objects into container

Parameters:

  | callStack | is used for tracing no wait loops, example: something.GetWaitObjects(c, CallStack("my func after X", 0)); or in an outer GetWaitObjects() method that itself takes a callStack parameter: innerThing.GetWaitObjects(c, CallStack("MyClass::GetWaitObjects at X", &callStack));

Implements Waitable.

Reimplemented in Redirector, NetworkSource, and NetworkSink.

Definition at line 182 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::GetWaitObjects().

Referenced by NetworkSource::GetWaitObjects(), and BufferedTransformation::GetWaitObjects().

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true` |
| ) |  |  | `[virtual, inherited]`

flush buffered input and/or output

Parameters:

  | hardFlush | is used to indicate whether all data should be flushed

Note:
  Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol.

Reimplemented in Filter, Redirector, OutputProxy, SecretSharing, InformationDispersal, Unflushable< Filter >, Unflushable< Sink >, Unflushable< Multichannel< Filter > >, Multichannel< Filter >, and Multichannel< Sink >.

Definition at line 195 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation().

Referenced by BufferedTransformation::ChannelFlush().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true` |
| ) |  |  | `[virtual, inherited]`

mark end of a series of messages

There should be a MessageEnd immediately before MessageSeriesEnd.

Reimplemented in Filter, Redirector, OutputProxy, Multichannel< Filter >, and Multichannel< Sink >.

Definition at line 201 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::IsolatedMessageSeriesEnd().

Referenced by EqualityComparisonFilter::ChannelMessageSeriesEnd(), BufferedTransformation::ChannelMessageSeriesEnd(), and EncodedObjectFilter::Put().

lword BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

returns number of bytes that is currently ready for retrieval

All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable().

Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, ByteQueue::Walker, and RandomPool.

Definition at line 247 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation(), BufferedTransformation::CopyTo(), and BufferedTransformation::MaxRetrievable().

Referenced by RandomNumberStore::AnyRetrievable(), Integer::BERDecode(), Integer::Decode(), DL_GroupParameters_EC< EC >::Initialize(), BufferedTransformation::MaxRetrievable(), EcRecommendedParameters< ECP >::NewEC(), EcRecommendedParameters< EC2N >::NewEC(), Integer::OpenPGPDecode(), and BufferedTransformation::TotalBytesRetrievable().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual, inherited]`

returns whether this object allows attachment

Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed.

Reimplemented in Filter.

Definition at line 948 of file cryptlib.h.

Referenced by BufferedTransformation::Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds,
|  | CallStack const & | callStack |
| ) |  |  | `[inherited]`

wait on this object

same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container

Definition at line 388 of file wait.cpp.

References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait().

Referenced by NetworkSink::DoFlush(), and NetworkSource::DoPump().

The documentation for this class was generated from the following file:

- asn.h